#import <AppGuardCore/AppGuard.h>
#import <AppGuardCore/AppGuardDefine.h>
static void APPGUARDCALLBACK(int type, int code, const char* desc)
{
    if( type == APPGUARD_TYPE_S2AUTH_CALLBACK)
    {
        char msg[256];
        sprintf(msg, "%d,%s", code, desc);
        UnitySendMessage("AppGuardUnityManager", "onS2AuthTryCallback", msg);
    } else if( type == APPGUARD_TYPE_KILL) {
        char msg[256];
        sprintf(msg, "%d", code);
        UnitySendMessage("AppGuardUnityManager", "onViolationCallback", msg);
    } else if( type == APPGUARD_TYPE_DETECT ) {
        char msg[256];
        sprintf(msg, "%d", (code * -1));
        UnitySendMessage("AppGuardUnityManager", "onViolationCallback", msg);
    }
}
char* MakeStringCopy (const char* string)
{
    if (string == NULL)
        return NULL;
    
    char* res = (char*)malloc(strlen(string) + 1);
    strcpy(res, string);
    return res;
}


extern "C"
{
    void AppGuardInit();
    const char* AppGuardGetUDID();
	void AppGuardSetUserID(const char* string);
	void AppGuardSetCertificationID(const char* string, long retryTimeSec);
    void AppGuardSetReserved1();
    void AppGuardStartCustomMacroMode();
    void AppGuardStopCustomMacroMode();
    void AppGuardSetCustomMacroRepeatEnable(bool bEnable);
    void AppGuardSetCustomMacroRepeatCount(int repeat);
    void AppGuardSetCustomMacroDensityEnable(bool bEnable);
    void AppGuardSetCustomMacroDensityRatio(int ratio);
    void AppGuardSetCustomMacroDensityConditionCount(int count);
    void AppGuardSetCustomMacroDensityConditionItemCount(int count);
    
}
void AppGuardInit()
{
    APPGUARD_INIT(APPGUARDCALLBACK);
}
const char* AppGuardGetUDID()
{
    const char* udid = APPGUARD_GET_UDID;
    return MakeStringCopy(udid);
}
void AppGuardSetUserID(const char* userid)
{
	APPGUARD_SET_USER_ID(userid);
}

void AppGuardSetCertificationID(const char* uniqueid, long retryTimeSec)
{
    if(retryTimeSec <= 0) {
        retryTimeSec = 180;
    }
	APPGUARD_SET_CERTIFICATION_ID(uniqueid, retryTimeSec);
}

void AppGuardSetReserved1() 
{
    APPGUARD_SET_RESERVED1;
}
void AppGuardStartCustomMacroMode()
{
    APPGUARD_START_CUSTOMMACROMODE;
}
void AppGuardStopCustomMacroMode()
{
    APPGUARD_STOP_CUSTOMMACROMODE;
}
void AppGuardSetCustomMacroRepeatEnable(bool bEnable)
{
    APPGUARD_SET_CUSTOMMACRO_REPEAT_ENABLE(bEnable);
}
void AppGuardSetCustomMacroRepeatCount(int repeat)
{
    APPGUARD_SET_CUSTOMMACRO_REPEAT_COUNT(repeat);
}
void AppGuardSetCustomMacroDensityEnable(bool bEnable)
{
    APPGUARD_SET_CUSTOMMACRO_DENSITY_ENABLE(bEnable);
}
void AppGuardSetCustomMacroDensityRatio(int ratio)
{
    APPGUARD_SET_CUSTOMMACRO_DENSITY_RATIO(ratio);
}
void AppGuardSetCustomMacroDensityConditionCount(int count)
{
    APPGUARD_SET_CUSTOMMACRO_DENSITY_CONDITION_COUNT(count);
}
void AppGuardSetCustomMacroDensityConditionItemCount(int count)
{
    APPGUARD_SET_CUSTOMMACRO_DENSITY_CONDITION_ITEM_COUNT(count);   
}
