//
//  AppGuardDefine.h
//  AppGuardCore
//
//  Copyright (c) 2016년 INCA Internet Corporation. All rights reserved.
//

#ifndef __APPGUARD_DEFINE_H__
#define __APPGUARD_DEFINE_H__

/*
 * AppGuard 버전
 */
#define APPGUARD_VERSION                                        "1.7.7"


/*
 * AppGuard 처리에 따른 종류
 */
#define APPGUARD_TYPE_EVENT                                     0
#define APPGUARD_TYPE_DETECT                                    1
#define APPGUARD_TYPE_ERROR                                     2
#define APPGUARD_TYPE_SECURE_COMMAND                            3
#define APPGUARD_TYPE_SECURE_ERROR                              4


/*
 * Event Type의 종류
 */
#define APPGUARD_EVENT_INITIALIZED                              0
#define APPGUARD_EVENT_START                                    1
#define APPGUARD_EVENT_STOP                                     2

/*
 * Detect Type의 종류
 */
#define DETECT_IOS_NOTHING                                  0
#define DETECT_IOS_INVALID_EXECUTION_FILE                   2
#define DETECT_IOS_INVALID_LOADED_EXECUTION_CODES           5
#define DETECT_IOS_CORE_SYSTEM_LIBRARY                      6
#define DETECT_IOS_DEBUGGING                               11
#define DETECT_IOS_REMOTE_CODE_INJECTING                   14
#define DETECT_IOS_RUNNING_BAD_APPLICATION                 21
#define DETECT_IOS_LOCAL_FILE_INTEGRITY                    27
#define DETECT_IOS_MACRO                                   28
#define DETECT_IOS_BUNDLE_NAME_INTEGRTIY                   30
#define DETECT_IOS_INSTALLED_BAD_APPLICATION               33 
#define DETECT_IOS_JAILBREAK_ENVIRONMENT                   34
#define DETECT_IOS_INVALID_IPA_PACKAGE                     37
#define DETECT_IOS_DEVELOPMENT_BUILD                       38



/*
 * Error Type의 종류
 */
#define APPGUARD_ERROR_NOTHING                                  0
#define APPGUARD_ERROR_RECEIVE_POLICY                           1
#define APPGUARD_ERROR_SEND_APP_HASH                            2
#define APPGUARD_ERROR_KEY_IS_NULL                              3
#define APPGUARD_ERROR_NETWORK_ACTIVATION                       4
#define APPGUARD_ERROR_APPGUARD_INIT                            5

/*
 * Secure Error Type의 종류
 */

#define SECURE_ERROR_BEGIN                                    -1
#define SECURE_ERROR_CHANNEL                                  0
#define SECURE_ERROR_POLICY                                   1
#define SECURE_ERROR_POLLING                                  2
#define SECURE_ERROR_CLIENTID                                 3
#define SECURE_V2_ERROR_CHANNEL                               10
#define SECURE_V2_ERROR_INTEGRITY                             11
#define SECURE_V2_ERROR_CLIENTID                              12
#define SECURE_ERROR_NETWORK_ACTIVATION                       7
#define SECURE_ERROR_NOTFOUND_CERTIFICATION_ID                8
#define SECURE_ERROR_NOTHING                                  9
/*
 * Secure command 의 종류
 */
#define SECURE_COMMAND_BEGIN                                    -1
#define SECURE_COMMAND_CHANNEL                                  0
#define SECURE_COMMAND_POLICY                                   1
#define SECURE_COMMAND_POLLING                                  2
#define SECURE_COMMAND_CLIENTID                                 3
#define SECURE_V2_COMMAND_CHANNEL                               10
#define SECURE_V2_COMMAND_INTEGRITY                             11
#define SECURE_V2_COMMAND_CLIENTID                              12
#define SECURE_COMMAND_END                                      13



#endif
